# Source for file Complex.php

Documentation is available at Complex.php

1. <?php
2. /*
3. * $Id: Complex.php 1482 2007-05-26 16:49:58Z zYne $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
21. Doctrine::autoload('Doctrine_Hook_Parser');
22. /**
23. * Doctrine_Hook_Parser_Complex
24. *
25. * @package Doctrine
26. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
27. * @category Object Relational Mapping
28. * @link www.phpdoctrine.com
29. * @since 1.0
30. * @version $Revision: 1482 $
31. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32. */
33. abstract class Doctrine_Hook_Parser_Complex extends Doctrine_Hook_Parser
34. {
35. /**
36. * parse
37. * Parses given field and field value to DQL condition
38. * and parameters. This method should always return
39. * prepared statement conditions (conditions that use
40. * placeholders instead of literal values).
41. *
42. * @param string $alias component alias
43. * @param string $field the field name
44. * @param mixed $value the value of the field
45. * @return void
46. */
47. public function parse($alias, $field, $value)
48. {
49. $this->condition = $this->parseClause($alias, $field, $value);
50. }
51. /**
52. * parseClause
53. *
54. * @param string $alias component alias
55. * @param string $field the field name
56. * @param mixed $value the value of the field
57. * @return void
58. */
59. public function parseClause($alias, $field, $value)
60. {
61. $parts = Doctrine_Tokenizer::quoteExplode($value, ' AND ');
63. if (count($parts) > 1) {
64. $ret = array();
65. foreach ($parts as $part) {
66. $ret[] = $this->parseSingle($alias, $field, $part);
67. }
69. $r = implode(' AND ', $ret);
70. } else {
71. $parts = Doctrine_Tokenizer::quoteExplode($value, ' OR ');
72. if (count($parts) > 1) {
73. $ret = array();
74. foreach ($parts as $part) {
75. $ret[] = $this->parseClause($alias, $field, $part);
76. }
78. $r = implode(' OR ', $ret);
79. } else {
80. $ret = $this->parseSingle($alias, $field, $parts[0]);
81. return $ret;
82. }
83. }
84. return '(' . $r . ')';
85. }
86. /**
87. * parseSingle
88. *
89. * @param string $alias component alias
90. * @param string $field the field name
91. * @param mixed $value the value of the field
92. * @return void
93. */
94. abstract public function parseSingle($alias, $field, $value);
95. }